Index: trunk/VUT/GtpVisibilityPreprocessor/src/VssTree.cpp
===================================================================
--- trunk/VUT/GtpVisibilityPreprocessor/src/VssTree.cpp	(revision 433)
+++ trunk/VUT/GtpVisibilityPreprocessor/src/VssTree.cpp	(revision 434)
@@ -26,8 +26,4 @@
 
 
-#define DEBUG_DIR_SPLIT 0
-
-
-
 // Static variables
 int
@@ -36,33 +32,32 @@
 inline void
 AddObject2Pvs(Intersectable *object,
-							const int side,
-							int &pvsBack,
-							int &pvsFront)
-{
-
-	if (!object)
-		return;
-		
-	if (side <= 0) {
-		if (!object->Mailed() && !object->Mailed(2)) {
-			pvsBack++;
-			if (object->Mailed(1))
-				object->Mail(2);
-			else
-				object->Mail();
-		}
-	}
-	
-	if (side >= 0) {
-		if (!object->Mailed(1) && !object->Mailed(2)) {
-			pvsFront++;
-			if (object->Mailed())
-				object->Mail(2);
-			else
-				object->Mail(1);
-		}
-	}
-}
-
+			  const int side,
+			  int &pvsBack,
+			  int &pvsFront)
+{
+  
+  if (!object)
+	return;
+  
+  if (side <= 0) {
+	if (!object->Mailed() && !object->Mailed(2)) {
+	  pvsBack++;
+	  if (object->Mailed(1))
+		object->Mail(2);
+	  else
+		object->Mail();
+	}
+  }
+  
+  if (side >= 0) {
+	if (!object->Mailed(1) && !object->Mailed(2)) {
+	  pvsFront++;
+	  if (object->Mailed())
+		object->Mail(2);
+	  else
+		object->Mail(1);
+	}
+  }
+}
 
 // Constructor
@@ -70,7 +65,7 @@
 {
   environment->GetIntValue("VssTree.maxDepth", termMaxDepth);
-	environment->GetIntValue("VssTree.minPvs", termMinPvs);
-	environment->GetIntValue("VssTree.minRays", termMinRays);
-	environment->GetFloatValue("VssTree.maxRayContribution", termMaxRayContribution);
+  environment->GetIntValue("VssTree.minPvs", termMinPvs);
+  environment->GetIntValue("VssTree.minRays", termMinRays);
+  environment->GetFloatValue("VssTree.maxRayContribution", termMaxRayContribution);
   environment->GetFloatValue("VssTree.maxCostRatio", termMaxCostRatio);
 
@@ -92,5 +87,5 @@
   float refDirAngle;
   environment->GetFloatValue("VssTree.refDirAngle", refDirAngle);
-
+  
   environment->GetIntValue("VssTree.accessTimeThreshold", accessTimeThreshold);
   //= 1000;
@@ -99,11 +94,11 @@
 
   //  pRefDirThresh = cos(0.5*M_PI - M_PI*refDirAngle/180.0);
-	//  cosRefDir = cos(M_PI*refDirAngle/180.0);
-	//  sinRefDir = sin(M_PI*refDirAngle/180.0);
+  //  cosRefDir = cos(M_PI*refDirAngle/180.0);
+  //  sinRefDir = sin(M_PI*refDirAngle/180.0);
   
   
   // split type
-	char sname[128];
-	environment->GetStringValue("VssTree.splitType", sname);
+  char sname[128];
+  environment->GetStringValue("VssTree.splitType", sname);
   string name(sname);
 	
@@ -113,11 +108,16 @@
     if (name.compare("heuristic") == 0)
       splitType = ESplitHeuristic;
-		else {
-			cerr<<"Invalid VssTree split type "<<name<<endl;
-			exit(1);
-		}
+	else
+	  if (name.compare("hybrid") == 0)
+		splitType = ESplitHybrid;
+	  else {
+		cerr<<"Invalid VssTree split type "<<name<<endl;
+		exit(1);
+	  }
 	
   environment->GetBoolValue("VssTree.randomize", randomize);
-
+  environment->GetBoolValue("VssTree.splitUseOnlyDrivingAxis", mSplitUseOnlyDrivingAxis);
+  environment->GetBoolValue("VssTree.useRss", mUseRss);
+	
   root = NULL;
   
@@ -143,5 +143,5 @@
       << rays <<endl;
 
-	app << "#N_INITPVS ( Initial PVS size )\n"
+  app << "#N_INITPVS ( Initial PVS size )\n"
       << initialPvsSize <<endl;
   
@@ -179,11 +179,11 @@
     minRaysNodes*100/(double)Leaves()<<endl;
 	
-	app << "#N_PMINSIZELEAVES  ( Percentage of leaves with minSize )\n"<<
+  app << "#N_PMINSIZELEAVES  ( Percentage of leaves with minSize )\n"<<
     minSizeNodes*100/(double)Leaves()<<endl;
 
-	app << "#N_PMAXRAYCONTRIBLEAVES  ( Percentage of leaves with maximal ray contribution )\n"<<
+  app << "#N_PMAXRAYCONTRIBLEAVES  ( Percentage of leaves with maximal ray contribution )\n"<<
     maxRayContribNodes*100/(double)Leaves()<<endl;
 
-	app << "#N_PMAXCOSTRATIOLEAVES  ( Percentage of leaves with max cost ratio )\n"<<
+  app << "#N_PMAXCOSTRATIOLEAVES  ( Percentage of leaves with max cost ratio )\n"<<
     maxCostRatioNodes*100/(double)Leaves()<<endl;
 
@@ -207,54 +207,54 @@
 VssTreeLeaf::UpdatePvsSize()
 {
-	if (!mValidPvs) {
-		Intersectable::NewMail();
-		int pvsSize = 0;
-		for(VssTreeNode::RayInfoContainer::iterator ri = rays.begin();
-				ri != rays.end();
-				ri++)
-			if ((*ri).mRay->IsActive()) {
-				Intersectable *object;
+  if (!mValidPvs) {
+	Intersectable::NewMail();
+	int pvsSize = 0;
+	for(VssTreeNode::RayInfoContainer::iterator ri = rays.begin();
+		ri != rays.end();
+		ri++)
+	  if ((*ri).mRay->IsActive()) {
+		Intersectable *object;
 #if BIDIRECTIONAL_RAY
-				object = (*ri).mRay->mOriginObject;
-				if (object && !object->Mailed()) {
-					pvsSize++;
-					object->Mail();
-				}
+		object = (*ri).mRay->mOriginObject;
+		if (object && !object->Mailed()) {
+		  pvsSize++;
+		  object->Mail();
+		}
 #endif
-				object = (*ri).mRay->mTerminationObject;
-				if (object && !object->Mailed()) {
-					pvsSize++;
-					object->Mail();
-				}
-			}
-		mPvsSize = pvsSize;
-		mValidPvs = true;
-	}
+		object = (*ri).mRay->mTerminationObject;
+		if (object && !object->Mailed()) {
+		  pvsSize++;
+		  object->Mail();
+		}
+	  }
+	mPvsSize = pvsSize;
+	mValidPvs = true;
+  }
 }
 
 bool
 VssTree::ClipRay(
-								 VssTreeNode::RayInfo &rayInfo,
-								 const AxisAlignedBox3 &box
-								 )
-{
-	float tmin, tmax;
-	static Ray ray;
-	ray.Init(rayInfo.mRay->GetOrigin(), rayInfo.mRay->GetDir(), Ray::LINE_SEGMENT);
-	box.ComputeMinMaxT(ray, &tmin, &tmax);
-	if (tmin >= tmax)
-		return false;
-	
-	if (tmin > 0.0f)
-		rayInfo.SetMinT(tmin);
-
-	if (tmax < 1.0f)
-		rayInfo.SetMaxT(tmax);
-	
-	//  	vssRay->SetupEndPoints(
-	//  												 origin,
-	//  												 termination
-	//  												 );
-	return true;
+				 VssTreeNode::RayInfo &rayInfo,
+				 const AxisAlignedBox3 &box
+				 )
+{
+  float tmin, tmax;
+  static Ray ray;
+  ray.Init(rayInfo.mRay->GetOrigin(), rayInfo.mRay->GetDir(), Ray::LINE_SEGMENT);
+  box.ComputeMinMaxT(ray, &tmin, &tmax);
+  if (tmin >= tmax)
+	return false;
+	
+  if (tmin > 0.0f)
+	rayInfo.SetMinT(tmin);
+
+  if (tmax < 1.0f)
+	rayInfo.SetMaxT(tmax);
+	
+  //  	vssRay->SetupEndPoints(
+  //  												 origin,
+  //  												 termination
+  //  												 );
+  return true;
 }
 
@@ -262,15 +262,15 @@
 void
 VssTree::Construct(
-									 VssRayContainer &rays,
-									 AxisAlignedBox3 *forcedBoundingBox
-									 )
+				   VssRayContainer &rays,
+				   AxisAlignedBox3 *forcedBoundingBox
+				   )
 {
   stat.Start();
   
-	maxMemory = maxStaticMemory;
+  maxMemory = maxStaticMemory;
 
   if (root)
     delete root;
-
+	
   root = new VssTreeLeaf(NULL, rays.size());
   // first construct a leaf that will get subdivide
@@ -281,14 +281,17 @@
   bbox.Initialize();
   dirBBox.Initialize();
-  
+
+  if (mUseRss)
+	forcedBoundingBox = NULL;
+	
   for(VssRayContainer::const_iterator ri = rays.begin();
       ri != rays.end();
       ri++) {
-
-		VssTreeNode::RayInfo info(*ri);
-		if (forcedBoundingBox)
-			if (!ClipRay(info, *forcedBoundingBox))
-				continue;
-		leaf->AddRay(info);
+		
+	VssTreeNode::RayInfo info(*ri);
+	if (forcedBoundingBox)
+	  if (!ClipRay(info, *forcedBoundingBox))
+		continue;
+	leaf->AddRay(info);
 		
     bbox.Include((*ri)->GetOrigin());
@@ -296,21 +299,21 @@
     
 		
-		dirBBox.Include(Vector3(
-														(*ri)->GetDirParametrization(0),
-														(*ri)->GetDirParametrization(1),
-														0
-														)
-										);
-	}
-	
-	
-	if ( forcedBoundingBox ) 
-		bbox = *forcedBoundingBox;
-	
-	cout<<"Bbox = "<<bbox<<endl;
-	cout<<"Dirr Bbox = "<<dirBBox<<endl;
+	dirBBox.Include(Vector3(
+							(*ri)->GetDirParametrization(0),
+							(*ri)->GetDirParametrization(1),
+							0
+							)
+					);
+  }
+	
+	
+  if ( forcedBoundingBox ) 
+	bbox = *forcedBoundingBox;
+	
+  cout<<"Bbox = "<<bbox<<endl;
+  cout<<"Dirr Bbox = "<<dirBBox<<endl;
 
   stat.rays = leaf->rays.size();
-	leaf->UpdatePvsSize();
+  leaf->UpdatePvsSize();
   stat.initialPvsSize = leaf->GetPvsSize();
   // Subdivide();
@@ -325,6 +328,6 @@
   stat.Stop();
 
-	stat.Print(cout);
-	cout<<"#Total memory="<<GetMemUsage()<<endl;
+  stat.Print(cout);
+  cout<<"#Total memory="<<GetMemUsage()<<endl;
 
 }
@@ -333,29 +336,29 @@
 VssTree::UpdateSubdivision()
 {
-	priority_queue<TraversalData> tStack;
+  priority_queue<TraversalData> tStack;
   //  stack<TraversalData> tStack;
   
-	tStack.push(TraversalData(root, bbox, 0));
+  tStack.push(TraversalData(root, bbox, 0));
 	
   AxisAlignedBox3 backBox;
   AxisAlignedBox3 frontBox;
 
-	maxMemory = maxTotalMemory;
-	int subdivided = 0;
-	int lastMem = 0;
+  maxMemory = maxTotalMemory;
+  int subdivided = 0;
+  int lastMem = 0;
   while (!tStack.empty()) {
 		
-		float mem = GetMemUsage();
-		
-		if ( lastMem/10 != ((int)mem)/10) {
-			cout<<mem<<" MB"<<endl;
-		}
-		lastMem = (int)mem;
-		
-		if (  mem > maxMemory ) {
+	float mem = GetMemUsage();
+		
+	if ( lastMem/10 != ((int)mem)/10) {
+	  cout<<mem<<" MB"<<endl;
+	}
+	lastMem = (int)mem;
+		
+	if (  mem > maxMemory ) {
       // count statistics on unprocessed leafs
       while (!tStack.empty()) {
-				//				EvaluateLeafStats(tStack.top());
-				tStack.pop();
+		//				EvaluateLeafStats(tStack.top());
+		tStack.pop();
       }
       break;
@@ -365,26 +368,26 @@
     tStack.pop();
 
-		if (data.node->IsLeaf()) {
-			VssTreeNode *node = SubdivideNode((VssTreeLeaf *) data.node,
-																				data.bbox,
-																				backBox,
-																				frontBox
-																				);
-			if (!node->IsLeaf()) {
-				subdivided++;
-				VssTreeInterior *interior = (VssTreeInterior *) node;
-				// push the children on the stack
-				tStack.push(TraversalData(interior->back, backBox, data.depth+1));
-				tStack.push(TraversalData(interior->front, frontBox, data.depth+1));
-			} else {
-				//      EvaluateLeafStats(data);
-			}
-		} else {
-			VssTreeInterior *interior = (VssTreeInterior *) data.node;
-			tStack.push(TraversalData(interior->back, GetBBox(interior->back), data.depth+1));
-			tStack.push(TraversalData(interior->front, GetBBox(interior->front), data.depth+1));
-		}
-  }
-	return subdivided;
+	if (data.node->IsLeaf()) {
+	  VssTreeNode *node = SubdivideNode((VssTreeLeaf *) data.node,
+										data.bbox,
+										backBox,
+										frontBox
+										);
+	  if (!node->IsLeaf()) {
+		subdivided++;
+		VssTreeInterior *interior = (VssTreeInterior *) node;
+		// push the children on the stack
+		tStack.push(TraversalData(interior->back, backBox, data.depth+1));
+		tStack.push(TraversalData(interior->front, frontBox, data.depth+1));
+	  } else {
+		//      EvaluateLeafStats(data);
+	  }
+	} else {
+	  VssTreeInterior *interior = (VssTreeInterior *) data.node;
+	  tStack.push(TraversalData(interior->back, GetBBox(interior->back), data.depth+1));
+	  tStack.push(TraversalData(interior->front, GetBBox(interior->front), data.depth+1));
+	}
+  }
+  return subdivided;
 }
 
@@ -404,19 +407,19 @@
 
   
-	int lastMem = 0;
+  int lastMem = 0;
   while (!tStack.empty()) {
 
-		float mem = GetMemUsage();
-		
-		if ( lastMem/10 != ((int)mem)/10) {
-			cout<<mem<<" MB"<<endl;
-		}
-		lastMem = (int)mem;
-		
-		if (  mem > maxMemory ) {
+	float mem = GetMemUsage();
+		
+	if ( lastMem/10 != ((int)mem)/10) {
+	  cout<<mem<<" MB"<<endl;
+	}
+	lastMem = (int)mem;
+		
+	if (  mem > maxMemory ) {
       // count statistics on unprocessed leafs
       while (!tStack.empty()) {
-				EvaluateLeafStats(tStack.top());
-				tStack.pop();
+		EvaluateLeafStats(tStack.top());
+		tStack.pop();
       }
       break;
@@ -427,8 +430,8 @@
     
     VssTreeNode *node = SubdivideNode((VssTreeLeaf *) data.node,
-																			data.bbox,
-																			backBox,
-																			frontBox
-																			);
+									  data.bbox,
+									  backBox,
+									  frontBox
+									  );
     if (result == NULL)
       result = node;
@@ -453,383 +456,432 @@
 int
 VssTree::SelectPlane(
-										 VssTreeLeaf *leaf,
-										 const AxisAlignedBox3 &box,
-										 float &position,
-										 int &raysBack,
-										 int &raysFront,
-										 int &pvsBack,
-										 int &pvsFront
-										 )
+					 VssTreeLeaf *leaf,
+					 const AxisAlignedBox3 &box,
+					 float &position,
+					 int &raysBack,
+					 int &raysFront,
+					 int &pvsBack,
+					 int &pvsFront
+					 )
 {
 
   int minDirDepth = 6;
   int axis;
-	float costRatio;
-	
-  if (splitType == ESplitRegular) {
-		costRatio = BestCostRatioRegular(leaf,
-																		 axis,
-																		 position,
-																		 raysBack,
-																		 raysFront,
-																		 pvsBack,
-																		 pvsFront
-																		 );
-
-	} else {
-    if (splitType == ESplitHeuristic)
-      costRatio = BestCostRatioHeuristic(leaf,
-																				 axis,
-																				 position,
-																				 raysBack,
-																				 raysFront,
-																				 pvsBack,
-																				 pvsFront
-																				 );
-		else {
+  float costRatio;
+	
+  costRatio = BestCostRatio(leaf,
+							axis,
+							position,
+							raysBack,
+							raysFront,
+							pvsBack,
+							pvsFront
+							);
+
+  //	cout<<axis<<" r="<<costRatio<<endl;
+	
+  if (costRatio > termMaxCostRatio) {
+	//		cout<<"Too big cost ratio "<<costRatio<<endl;
+	stat.maxCostRatioNodes++;
+	return -1;
+  }
+	
+#if 0	
+  cout<<
+	"pvs="<<leaf->mPvsSize<<
+	" rays="<<leaf->rays.size()<<
+	" rc="<<leaf->GetAvgRayContribution()<<
+	" axis="<<axis<<endl;
+#endif
+	
+  return axis;
+}
+
+
+float
+VssTree::GetCostRatio(
+					  VssTreeLeaf *leaf,
+					  const int axis,
+					  const float position,
+					  const int raysBack,
+					  const int raysFront,
+					  const int pvsBack,
+					  const int pvsFront
+					  )
+{
+  bool costImportance = true;
+
+  float ratio;
+  AxisAlignedBox3 box;
+  float minBox, maxBox;
+
+  if (axis < 3) {
+	box = GetBBox(leaf);
+	minBox = box.Min(axis);
+	maxBox = box.Max(axis);
+  }	else {
+	box = GetDirBBox(leaf);
+	minBox = box.Min(axis-3);
+	maxBox = box.Max(axis-3);
+  }
+	
+  float sizeBox = maxBox - minBox;
+
+  int pvsSize = leaf->GetPvsSize();
+
+  if (!costImportance) {
+	//		float sum = raysBack*(position - minBox) + raysFront*(maxBox - position);
+	float sum = pvsBack*(position - minBox) + pvsFront*(maxBox - position);
+	float newCost = ct_div_ci + sum/sizeBox;
+	float oldCost = pvsSize;
+	ratio = newCost/oldCost;
+  } else {
+	// importance based cost
+#if 0
+	float newContrib =
+	  ((position - minBox)*sqr(pvsBack/(raysBack + Limits::Small)) +
+	   (maxBox - position)*sqr(pvsFront/(raysFront + Limits::Small)))/sizeBox;
+		
+	//			float newContrib =
+	//				sqr(pvsBack/(raysBack + Limits::Small)) +
+	//				sqr(pvsFront/(raysFront + Limits::Small));
+	float oldContrib = sqr(leaf->GetAvgRayContribution());
+	ratio = oldContrib/newContrib;
+#else
+#if 1
+	float newCost = raysBack*pvsBack  + raysFront*pvsFront;
+	float oldCost = leaf->rays.size()*pvsSize;
+	ratio = newCost/oldCost;
+#else
+	float newCost = (pvsBack  + pvsFront)*0.5f;
+	float oldCost = pvsSize;
+	ratio = newCost/oldCost;
+#endif
+#endif
+  }
+	
+  return ratio;
+}
+							
+
+float
+VssTree::EvalCostRatio(
+					   VssTreeLeaf *leaf,
+					   const int axis,
+					   const float position,
+					   int &raysBack,
+					   int &raysFront,
+					   int &pvsBack,
+					   int &pvsFront
+					   )
+{
+  raysBack = 0;
+  raysFront = 0;
+  pvsFront = 0;
+  pvsBack = 0;
+
+	
+  Intersectable::NewMail(3);
+	
+  if (axis <= VssTreeNode::SPLIT_Z) {
+    // this is the main ray classification loop!
+    for(VssTreeNode::RayInfoContainer::iterator ri = leaf->rays.begin();
+		ri != leaf->rays.end();
+		ri++)
+      if ((*ri).mRay->IsActive()) {
+				
+		// determine the side of this ray with respect to the plane
+		int side = (*ri).ComputeRayIntersection(axis, position, (*ri).mRay->mT);
+		//				(*ri).mRay->mSide = side;
+				
+		if (side <= 0)
+		  raysBack++;
+				
+		if (side >= 0)
+		  raysFront++;
+				
+		AddObject2Pvs((*ri).mRay->mTerminationObject, side, pvsBack, pvsFront);
+      }
+		
+  } else {
+		
+	// directional split
+    for(VssTreeNode::RayInfoContainer::iterator ri = leaf->rays.begin();
+		ri != leaf->rays.end();
+		ri++)
+      if ((*ri).mRay->IsActive()) {
+				
+		// determine the side of this ray with respect to the plane
+		int side;
+		if ((*ri).mRay->GetDirParametrization(axis - 3) > position)
+		  side = 1;
+		else
+		  side = -1;
+
+		if (side <= 0)
+		  raysBack++;
+				
+		if (side >= 0)
+		  raysFront++;
+
+		//				(*ri).mRay->mSide = side;
+		AddObject2Pvs((*ri).mRay->mTerminationObject, side, pvsBack, pvsFront);
+				
+      }
+  }
+
+  float ratio = GetCostRatio(
+							 leaf,
+							 axis,
+							 position,
+							 raysBack,
+							 raysFront,
+							 pvsBack,
+							 pvsFront);
+
+  //	cout<<axis<<" "<<pvsSize<<" "<<pvsBack<<" "<<pvsFront<<endl;
+  //  float oldCost = leaf->rays.size();
+
+  //	cout<<"ratio="<<ratio<<endl;
+
+  return ratio;
+}
+
+float
+VssTree::BestCostRatio(
+					   VssTreeLeaf *leaf,
+					   int &axis,
+					   float &position,
+					   int &raysBack,
+					   int &raysFront,
+					   int &pvsBack,
+					   int &pvsFront
+					   )
+{
+  int nRaysBack[6], nRaysFront[6];
+  int nPvsBack[6], nPvsFront[6];
+  float nPosition[6];
+  float nCostRatio[6];
+  int bestAxis = -1;
+	
+  AxisAlignedBox3 sBox = GetBBox(leaf);
+  AxisAlignedBox3 dBox = GetDirBBox(leaf);
+  // int sAxis = box.Size().DrivingAxis();
+  int sAxis = sBox.Size().DrivingAxis();
+  int dAxis = dBox.Size().DrivingAxis() + 3;
+
+
+  float dirSplitBoxSize = 0.01f;
+  bool allowDirSplit = Magnitude(sBox.Size())*dirSplitBoxSize < Magnitude(bbox.Size());
+		
+
+  for (axis = 0; axis < 5; axis++) {
+	if (!mSplitUseOnlyDrivingAxis || axis == sAxis || axis == dAxis) {
+
+
+	  if (splitType == ESplitRegular) {
+		if (axis < 3)
+		  nPosition[axis] = (sBox.Min()[axis] + sBox.Max()[axis])*0.5f;
+		else
+		  nPosition[axis] = (dBox.Min()[axis-3] + dBox.Max()[axis-3])*0.5f;
+				
+		nCostRatio[axis] = EvalCostRatio(leaf,
+										 axis,
+										 nPosition[axis],
+										 nRaysBack[axis],
+										 nRaysFront[axis],
+										 nPvsBack[axis],
+										 nPvsFront[axis]
+										 );
+	  } else
+		if (splitType == ESplitHeuristic) {
+		  nCostRatio[axis] = EvalCostRatioHeuristic(
+													leaf,
+													axis,
+													nPosition[axis],
+													nRaysBack[axis],
+													nRaysFront[axis],
+													nPvsBack[axis],
+													nPvsFront[axis]);
+		} else
+		  if (splitType == ESplitHybrid) {
+			if (leaf->depth > 7)
+			  nCostRatio[axis] = EvalCostRatioHeuristic(
+														leaf,
+														axis,
+														nPosition[axis],
+														nRaysBack[axis],
+														nRaysFront[axis],
+														nPvsBack[axis],
+														nPvsFront[axis]);
+			else {
+			  if (axis < 3)
+				nPosition[axis] = (sBox.Min()[axis] + sBox.Max()[axis])*0.5f;
+			  else
+				nPosition[axis] = (dBox.Min()[axis-3] + dBox.Max()[axis-3])*0.5f;
+							
+			  nCostRatio[axis] = EvalCostRatio(leaf,
+											   axis,
+											   nPosition[axis],
+											   nRaysBack[axis],
+											   nRaysFront[axis],
+											   nPvsBack[axis],
+											   nPvsFront[axis]
+											   );
+			}
+		  } else {
 			cerr<<"VssTree: Unknown split heuristics\n";
 			exit(1);
-		}
-  }
-
-	if (costRatio > termMaxCostRatio) {
-		//		cout<<"Too big cost ratio "<<costRatio<<endl;
-		stat.maxCostRatioNodes++;
-		return -1;
-	}
-
-#if 0	
-	cout<<
-		"pvs="<<leaf->mPvsSize<<
-		" rays="<<leaf->rays.size()<<
-		" rc="<<leaf->GetAvgRayContribution()<<
-		" axis="<<axis<<endl;
-#endif
-	
-	return axis;
-}
-
-
-							
-
+		  }
+			
+				
+	  if ( bestAxis == -1)
+		bestAxis = axis;
+	  else
+		if ( nCostRatio[axis] < nCostRatio[bestAxis] )
+		  bestAxis = axis;
+	}
+  }
+
+  axis = bestAxis;
+  position = nPosition[bestAxis];
+
+  raysBack = nRaysBack[bestAxis];
+  raysFront = nRaysFront[bestAxis];
+
+  pvsBack = nPvsBack[bestAxis];
+  pvsFront = nPvsFront[bestAxis];
+	
+  return nCostRatio[bestAxis];
+}
+
+	
 float
-VssTree::EvalCostRatio(
-											 VssTreeLeaf *leaf,
-											 const int axis,
-											 const float position,
-											 int &raysBack,
-											 int &raysFront,
-											 int &pvsBack,
-											 int &pvsFront
-											 )
-{
-	raysBack = 0;
-	raysFront = 0;
-	pvsFront = 0;
-	pvsBack = 0;
-
-
-	Intersectable::NewMail(3);
-	bool costImportance = true;
-	// eval pvs size
-	int pvsSize = leaf->GetPvsSize();
-	float ratio;
-
-	Intersectable::NewMail(3);
-
-	if (axis <= VssTreeNode::SPLIT_Z) {
-    // this is the main ray classification loop!
-    for(VssTreeNode::RayInfoContainer::iterator ri = leaf->rays.begin();
-				ri != leaf->rays.end();
-				ri++)
-      if ((*ri).mRay->IsActive()) {
-				
-				// determine the side of this ray with respect to the plane
-				int side = (*ri).ComputeRayIntersection(axis, position, (*ri).mRay->mT);
-				//				(*ri).mRay->mSide = side;
-				
-				if (side <= 0)
-					raysBack++;
-				
-				if (side >= 0)
-					raysFront++;
-				
-				AddObject2Pvs((*ri).mRay->mTerminationObject, side, pvsBack, pvsFront);
-      }
-
-		AxisAlignedBox3 box = GetBBox(leaf);
-		
-		float minBox = box.Min(axis);
-		float maxBox = box.Max(axis);
-		float sizeBox = maxBox - minBox;
-		
-		if (!costImportance) {
+VssTree::EvalCostRatioHeuristic(
+								VssTreeLeaf *leaf,
+								const int axis,
+								float &bestPosition,
+								int &raysBack,
+								int &raysFront,
+								int &pvsBack,
+								int &pvsFront
+								)
+{
+  AxisAlignedBox3 box;
+  float minBox, maxBox;
+	
+  if (axis < 3) {
+	box = GetBBox(leaf);
+	minBox = box.Min(axis);
+	maxBox = box.Max(axis);
+  }
+  else {
+	box = GetDirBBox(leaf);
+	minBox = box.Min(axis-3);
+	maxBox = box.Max(axis-3);
+  }
+	
+  SortSplitCandidates(leaf, axis);
+  
+  // go through the lists, count the number of objects left and right
+  // and evaluate the following cost funcion:
+  // C = ct_div_ci  + (ql*rl + qr*rr)/queries
+	
+  int rl=0, rr = leaf->rays.size();
+  int pl=0, pr = leaf->GetPvsSize();
+  float sizeBox = maxBox - minBox;
+	
+  float minBand = minBox + 0.1*(maxBox - minBox);
+  float maxBand = minBox + 0.9*(maxBox - minBox);
+	
+  float minRatio = 1e20;
+	
+  Intersectable::NewMail();
+  // set all object as belonging to the fron pvs
+  for(VssTreeNode::RayInfoContainer::iterator ri = leaf->rays.begin();
+	  ri != leaf->rays.end();
+	  ri++)
+	if ((*ri).mRay->IsActive()) {
+	  Intersectable *object = (*ri).mRay->mTerminationObject;
+	  if (object)
+		if (!object->Mailed()) {
+		  object->Mail();
+		  object->mCounter = 1;
+		} else
+		  object->mCounter++;
+	}
+	
+  Intersectable::NewMail();
+	
+  for(vector<SortableEntry>::const_iterator ci = splitCandidates->begin();
+	  ci < splitCandidates->end();
+	  ci++) {
+	VssRay *ray;
+	switch ((*ci).type) {
+	case SortableEntry::ERayMin: {
+	  rl++;
+	  ray = (VssRay *) (*ci).data;
+	  Intersectable *object = ray->mTerminationObject;
+	  if (object && !object->Mailed()) {
+		object->Mail();
+		pl++;
+	  }
+	  break;
+	}
+	case SortableEntry::ERayMax: {
+	  rr--;
+	  ray = (VssRay *) (*ci).data;
+	  Intersectable *object = ray->mTerminationObject;
+	  if (object) {
+		if (--object->mCounter == 0)
+		  pr--;
+	  }
+	  break;
+	}
+	}
+
+	float position = (*ci).value;
+		
+	if (position > minBand && position < maxBand) {
 			
-			//		float sum = raysBack*(position - minBox) + raysFront*(maxBox - position);
-			float sum = pvsBack*(position - minBox) + pvsFront*(maxBox - position);
-			float newCost = ct_div_ci + sum/sizeBox;
-			float oldCost = pvsSize;
-			ratio = newCost/oldCost;
-		} else {
-			// importance based cost
-#if 0
-			float newContrib =
-				((position - minBox)*sqr(pvsBack/(raysBack + Limits::Small)) +
-				 (maxBox - position)*sqr(pvsFront/(raysFront + Limits::Small)))/sizeBox;
-
-			//			float newContrib =
-			//				sqr(pvsBack/(raysBack + Limits::Small)) +
-			//				sqr(pvsFront/(raysFront + Limits::Small));
-			float oldContrib = sqr(leaf->GetAvgRayContribution());
-			ratio = oldContrib/newContrib;
-#else
-			float newCost = raysBack*pvsBack  + raysFront*pvsFront;
-			float oldCost = leaf->rays.size()*pvsSize;
-			ratio = newCost/oldCost;
-#endif
-		}
-		
-  } else {
-		
-		// directional split
-    for(VssTreeNode::RayInfoContainer::iterator ri = leaf->rays.begin();
-				ri != leaf->rays.end();
-				ri++)
-      if ((*ri).mRay->IsActive()) {
-				
-				// determine the side of this ray with respect to the plane
-				int side;
-				if ((*ri).mRay->GetDirParametrization(axis - 3) > position)
-					side = 1;
-				else
-					side = -1;
-
-				if (side <= 0)
-					raysBack++;
-				
-				if (side >= 0)
-					raysFront++;
-
-				//				(*ri).mRay->mSide = side;
-				AddObject2Pvs((*ri).mRay->mTerminationObject, side, pvsBack, pvsFront);
-				
-      }
-		
-		AxisAlignedBox3 box = GetDirBBox(leaf);
-		
-		float minBox = box.Min(axis-3);
-		float maxBox = box.Max(axis-3);
-		float sizeBox = maxBox - minBox;
-
-		if (!costImportance) {
+	  float ratio = GetCostRatio(
+								 leaf,
+								 axis,
+								 position,
+								 rl,
+								 rr,
+								 pl,
+								 pr);
 			
-			float directionalPenalty = 1.0f;
-			float sum =
-				(pvsBack*(position - minBox) +
-				 pvsFront*(maxBox - position))*directionalPenalty;
-			float newCost = ct_div_ci + sum/sizeBox;
-			float oldCost = pvsSize;
-			ratio = newCost/oldCost;
-		} else {
-#if 0
-			float directionalPenalty = 0.7f;
-			// importance based cost
-			float newContrib =
-				directionalPenalty*((position - minBox)*sqr(pvsBack/(raysBack + Limits::Small)) +
-														(maxBox - position)*sqr(pvsFront/(raysFront + Limits::Small)))/sizeBox;
-			float oldContrib = sqr(leaf->GetAvgRayContribution());
-			ratio = oldContrib/newContrib;
-#else
-			float newCost = raysBack*pvsBack  + raysFront*pvsFront;
-			float oldCost = leaf->rays.size()*pvsSize;
-			ratio = newCost/oldCost;
-#endif
-		}
-	}
-	//	cout<<axis<<" "<<pvsSize<<" "<<pvsBack<<" "<<pvsFront<<endl;
-	//  float oldCost = leaf->rays.size();
-
-	//	cout<<"ratio="<<ratio<<endl;
-	return ratio;
-}
-
-float
-VssTree::BestCostRatioRegular(
-															VssTreeLeaf *leaf,
-															int &axis,
-															float &position,
-															int &raysBack,
-															int &raysFront,
-															int &pvsBack,
-															int &pvsFront
-															)
-	{
-	int nRaysBack[6], nRaysFront[6];
-	int nPvsBack[6], nPvsFront[6];
-	float nPosition[6];
-	float nCostRatio[6];
-	int bestAxis = -1;
-	
-	AxisAlignedBox3 sBox = GetBBox(leaf);
-	AxisAlignedBox3 dBox = GetDirBBox(leaf);
-	// int sAxis = box.Size().DrivingAxis();
-	int sAxis = sBox.Size().DrivingAxis();
-	int dAxis = dBox.Size().DrivingAxis() + 3;
-
-	bool onlyDrivingAxis = false; 
-
-	float dirSplitBoxSize = 0.01f;
-	bool allowDirSplit = Magnitude(sBox.Size())*dirSplitBoxSize < Magnitude(bbox.Size());
-		
-
-	for (axis = 0; axis < 5; axis++) {
-		if (!onlyDrivingAxis || axis == sAxis || axis == dAxis) {
-			if (axis < 3)
-				nPosition[axis] = (sBox.Min()[axis] + sBox.Max()[axis])*0.5f;
-			else
-				nPosition[axis] = (dBox.Min()[axis-3] + dBox.Max()[axis-3])*0.5f;
 			
-			nCostRatio[axis] = EvalCostRatio(leaf,
-																			 axis,
-																			 nPosition[axis],
-																			 nRaysBack[axis],
-																			 nRaysFront[axis],
-																			 nPvsBack[axis],
-																			 nPvsFront[axis]
-																			 );
+	  //      cout<<"pos="<<(*ci).value<<"\t q=("<<ql<<","<<qr<<")\t r=("<<rl<<","<<rr<<")"<<endl;
+	  //      cout<<"cost= "<<sum<<endl;
 			
-			if ( bestAxis == -1)
-				bestAxis = axis;
-			else
-				if ( nCostRatio[axis] < nCostRatio[bestAxis] )
-					bestAxis = axis;
-		}
-	}
-
-	axis = bestAxis;
-	position = nPosition[bestAxis];
-
-	raysBack = nRaysBack[bestAxis];
-	raysFront = nRaysFront[bestAxis];
-
-	pvsBack = nPvsBack[bestAxis];
-	pvsFront = nPvsFront[bestAxis];
-	
-	return nCostRatio[bestAxis];
-}
-
-float
-VssTree::BestCostRatioHeuristic(
-																VssTreeLeaf *leaf,
-																int &axis,
-																float &position,
-																int &raysBack,
-																int &raysFront,
-																int &pvsBack,
-																int &pvsFront
-																)
-{
-	AxisAlignedBox3 box = GetBBox(leaf);
-	//	AxisAlignedBox3 dirBox = GetDirBBox(node);
-	
-	axis = box.Size().DrivingAxis();
-		
-	SortSplitCandidates(leaf, axis);
-  
-	// go through the lists, count the number of objects left and right
-	// and evaluate the following cost funcion:
-	// C = ct_div_ci  + (ql*rl + qr*rr)/queries
-	
-	int rl=0, rr = leaf->rays.size();
-	int pl=0, pr = leaf->GetPvsSize();
-	float minBox = box.Min(axis);
-	float maxBox = box.Max(axis);
-	float sizeBox = maxBox - minBox;
-	
-	float minBand = minBox + 0.1*(maxBox - minBox);
-	float maxBand = minBox + 0.9*(maxBox - minBox);
-	
-	float sum = rr*sizeBox;
-	float minSum = 1e20;
-	
-	Intersectable::NewMail();
-	// set all object as belonging to the fron pvs
-	for(VssTreeNode::RayInfoContainer::iterator ri = leaf->rays.begin();
-			ri != leaf->rays.end();
-			ri++)
-		if ((*ri).mRay->IsActive()) {
-			Intersectable *object = (*ri).mRay->mTerminationObject;
-			if (object)
-				if (!object->Mailed()) {
-					object->Mail();
-					object->mCounter = 1;
-				} else
-					object->mCounter++;
-		}
-	
-	Intersectable::NewMail();
-	
-	for(vector<SortableEntry>::const_iterator ci = splitCandidates->begin();
-			ci < splitCandidates->end();
-			ci++) {
-		VssRay *ray;
-		switch ((*ci).type) {
-		case SortableEntry::ERayMin: {
-			rl++;
-			ray = (VssRay *) (*ci).data;
-			Intersectable *object = ray->mTerminationObject;
-			if (object && !object->Mailed()) {
-				object->Mail();
-				pl++;
-			}
-			break;
-		}
-		case SortableEntry::ERayMax: {
-			rr--;
-			ray = (VssRay *) (*ci).data;
-			Intersectable *object = ray->mTerminationObject;
-			if (object) {
-				if (--object->mCounter == 0)
-					pr--;
-			}
-			break;
-		}
-		}
-		if ((*ci).value > minBand && (*ci).value < maxBand) {
-			
-			sum = pl*((*ci).value - minBox) + pr*(maxBox - (*ci).value);
-			
-			//      cout<<"pos="<<(*ci).value<<"\t q=("<<ql<<","<<qr<<")\t r=("<<rl<<","<<rr<<")"<<endl;
-			//      cout<<"cost= "<<sum<<endl;
-			
-			if (sum < minSum) {
-				minSum = sum;
-				position = (*ci).value;
-				
-				raysBack = rl;
-				raysFront = rr;
-				
-				pvsBack = pl;
-				pvsFront = pr;
+	  if (ratio < minRatio) {
+		minRatio = ratio;
+		bestPosition = position;
+				
+		raysBack = rl;
+		raysFront = rr;
+				
+		pvsBack = pl;
+		pvsFront = pr;
 				
       }
     }
   }
-  
-  float oldCost = leaf->GetPvsSize();
-  float newCost = ct_div_ci + minSum/sizeBox;
-  float ratio = newCost/oldCost;
+
   
   //  cout<<"===================="<<endl;
   //  cout<<"costRatio="<<ratio<<" pos="<<position<<" t="<<(position - minBox)/(maxBox - minBox)
   //      <<"\t q=("<<queriesBack<<","<<queriesFront<<")\t r=("<<raysBack<<","<<raysFront<<")"<<endl;
-	return ratio;
+  return minRatio;
 }
 
 void
 VssTree::SortSplitCandidates(
-														 VssTreeLeaf *node,
-														 const int axis
-														 )
+							 VssTreeLeaf *node,
+							 const int axis
+							 )
 {
   
